'''Game main module.

DIS IS MY GAME!
By Eugman
'''

import pyglet, math, copy
from pyglet.gl import *
from pyglet.window import key
from pyglet.window import mouse



##functions

            
def tog(x):
    """Converts an x or a y to the grid number"""
    return (x+20)//40

def drawsquare((x,y),(l,w),color):
    pyglet.graphics.draw(4,GL_QUADS,('v2f',(x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),
        ('c4B', color*4))
    
def gridcheck(grid,(x,y)):
    if grid[x][y] and grid[x][y].ends[0] and grid[x][y+1]:
        grid[x][y].ends=(0,0,0,1)
    
    
    
def convert(conv):
    if conv.HASBOX:
        conv.ends=(1,1,1,1)
        conv.HASBOX=False
    elif conv.ends in ((1,0,1,0),(0,1,0,1)):
        conv.ends=(1,1,0,0)
    elif conv.ends in ((1,1,0,0),(0,1,1,0),(0,0,1,1),(1,0,0,1)):
        conv.ends=(1,1,0,1)
    elif conv.ends in ((1,1,0,1),(1,1,1,0),(0,1,1,1),(1,0,1,1)):
        conv.HASBOX=True
    elif conv.ends==(1,1,1,1):
        conv.ends=(1,0,1,0)
    
        
    





##Classes
         

class square(object):
    def __init__(self,pos,(x,y)):
        self.vel=[0,-1]
        self.pos=pos
        self.lw=[x,y]
        self.color=(250,250,250,255)
    def draw(self):
        drawsquare(self.pos,self.lw,self.color)
    def update(self,dt):
        pass
    def move(self,x,y):
         self.pos[0]+=x
         self.pos[1]+=y

class conveyor(object):
    def __init__(self):
        self.ends=(1,1,0,0)
        self.color=(255,255,255,255)
        self.pos=[-100,-100]
        self.HASBOX=False
        self.ISFULL=False
    def draw(self):
        if self.HASBOX:
            drawsquare(self.pos,(15,15),(75,75,25,255))
        for i in range(4):
            if self.ends[i]:
                if i%2:
                    #Right or Left
                    l=10
                    w=5
                    x=self.pos[0]+(i-2)*10
                    y=self.pos[1]
                else:
                    #Top or bottom
                    l=5
                    w=10
                    x=self.pos[0]
                    y=self.pos[1]+(i-1)*-10   
                pyglet.graphics.draw(4,pyglet.gl.GL_QUADS,('v2f',(x-l,y-w,x+l,y-w,x+l,y+w,x-l,y+w)),('c4B', self.color*4))
    def update(self,dt):
        pass
    def rotate(self,direction):
        if direction==1:
            self.ends=self.ends[-1:]+self.ends[:-1]
        elif direction==-1:
            self.ends=self.ends[1:]+self.ends[:1]

##Main
def main():
    

    grid=[[[] for x in xrange(40)] for x in xrange(40)]
    
    
    window=pyglet.window.Window(800,600,"Quadrangles of Fury")
    window.clear()
    mouseblock=conveyor()
    overlay=square([-100,-100],[20,20])
    
    
    pyglet.gl.glBlendFunc(pyglet.gl.GL_SRC_ALPHA, pyglet.gl.GL_ONE_MINUS_SRC_ALPHA)
    pyglet.gl.glEnable(pyglet.gl.GL_BLEND)
    @window.event
    def on_key_press(symbol,modifiers):
        if symbol==key.A:
            mouseblock.rotate(-1)
        if symbol==key.D:
            mouseblock.rotate(1)
        if symbol==key.W:
            convert(mouseblock)
        elif symbol==key.S:
            convert(mouseblock)
            convert(mouseblock)
            convert(mouseblock)
            convert(mouseblock)
    
    @window.event
    def on_mouse_press(x, y, button, modifiers):
        if 0<=tog(x)<=8 and 0<tog(y)<12:
            if button==mouse.LEFT:
                if not grid[tog(x)][tog(y)]:
                    grid[tog(x)][tog(y)]=copy.copy(mouseblock)
            if button==mouse.RIGHT:
                grid[tog(x)][tog(y)]=0

    @window.event
    def on_mouse_motion(x,y,dx,dy):
        mouseblock.pos=[40*tog(x),40*tog(y)]
        overlay.pos=mouseblock.pos
  
    @window.event
    def on_draw():
        window.clear()
        drawsquare((400,300),(400,300),(96,220,96,200))
        for i in grid:
            for j in i:
                if j: j.draw()
        if 0<tog(mouseblock.pos[0])<8 and 0<tog(mouseblock.pos[1])<12:
            overlay.draw()
            mouseblock.draw()
    
    def update(dt):
        for i in grid:
            for j in i:
                if j: j.update(dt)
                    
        if  not 0<tog(mouseblock.pos[0])<8 or  not 0<tog(mouseblock.pos[1])<12 or grid[tog(mouseblock.pos[0])][tog(mouseblock.pos[1])]:
            overlay.color=(250,100,100,200)
        else:
            overlay.color=(128,128,255,96) 
                
        
        
                
                
                
    pyglet.clock.schedule_interval(update, 1/30.)
    pyglet.app.run()

if __name__ == '__main__':
    main()
